package org.jboss.security;

package .tmp;

import java.util.ArrayList;
import org.jboss.security.SecurityAssociation;

class SubjectThreadLocalStack {
  ThreadLocal local;
  
  SubjectThreadLocalStack(boolean threadLocal) {
    if (threadLocal == true) {
      this.local = (ThreadLocal)new SecurityAssociation.ArrayListLocal(null);
    } else {
      this.local = (ThreadLocal)new SecurityAssociation.ArrayListInheritableLocal(null);
    } 
  }
  
  void push(SecurityAssociation.SubjectContext context) {
    ArrayList stack = this.local.get();
    stack.add(context);
  }
  
  SecurityAssociation.SubjectContext dup() {
    ArrayList stack = this.local.get();
    SecurityAssociation.SubjectContext context = null;
    int lastIndex = stack.size() - 1;
    if (lastIndex >= 0) {
      context = stack.get(lastIndex);
      stack.add(context);
    } 
    return context;
  }
  
  SecurityAssociation.SubjectContext pop() {
    ArrayList stack = this.local.get();
    SecurityAssociation.SubjectContext context = null;
    int lastIndex = stack.size() - 1;
    if (lastIndex >= 0)
      context = stack.remove(lastIndex); 
    return context;
  }
  
  SecurityAssociation.SubjectContext peek() {
    ArrayList stack = this.local.get();
    SecurityAssociation.SubjectContext context = null;
    int lastIndex = stack.size() - 1;
    if (lastIndex >= 0)
      context = stack.get(lastIndex); 
    return context;
  }
  
  void clear() {
    ArrayList stack = this.local.get();
    stack.clear();
  }
}
